<?php
/**
 * Copyright 2000 - 2003 by Gero Kohnert
 *
 * @modulegroup file
 * @module file_new
 * @package file
 */
 $tutos['base'] = "../..";
 ini_set("include_path","..");
 include_once 'webelements.p3';
 include_once 'permission.p3';
 include_once 'product.pinc';

 /* Check if user is allowed to use it */
 check_user();
 loadmodules('file','import');
 loadmodule('file');
 loadlayout();

 /**
  * impot files
  */
 class file_massimport extends layout {
   /**
    * display the form
    */

   Function info() {
     global $tutos,$lang,$table;

     echo "<form name=\"fileimport\" method=\"get\" action=\"file_massimport.php\">\n";
     echo $this->DataTableStart();

     echo "<tr>\n".$this->mode;
     echo $this->showfieldc($lang['FileReference']);
     echo " <td colspan=\"3\">\n";
     if ( ($this->ref != 0) && ($this->mode == 0) ) {
       echo $lang[$this->ref->gettype()] ." ". $this->ref->getLink();
       $this->addHidden("pid", $this->ref->id);
     } else {
       select_from_array_or_input($this,"p",$this->ref,0);
     }
     echo " </td>\n";
     echo "</tr>\n";

     echo "<tr>\n";
     echo $this->showfieldc($lang['FileAuthor'],0,"a");
     echo " <td colspan=\"3\">\n";
     select_from_array_or_input($this,"a",$this->author,0);
     echo " </td>\n";
     echo "</tr>\n";

     echo "<tr>\n";
     echo $this->showfieldc("PATH on server");
     echo "<td colspan=\"3\"><input id=\"serverpath\" size=\"40\" name=\"serverpath\" value=\"". $this->serverpath ."\">\n";
     echo "</td>\n";
     echo "</tr>\n";

     echo "<tr>\n";
     echo $this->showfieldc("ACTION");
     echo "<td colspan=\"3\">";
     echo "<input type=\"radio\" name=\"action\" value=\"1\">Edit Values";
     echo "<input type=\"radio\" name=\"action\" value=\"2\" checked>Test";
     echo "<input type=\"radio\" name=\"action\" value=\"9\">Run";
     echo "</td>\n";
     echo "</tr>\n";

     echo "<tr>\n";
     if ( isset($this->obj->id) && ($this->obj->id != -1) ) {
       submit_reset(0,1,1,1,1,0);
     } else {
       submit_reset(0,-1,1,1,1,0);
     }
     echo "</tr>\n";

     echo $this->DataTableEnd();
     $this->addHidden("mark","dummy");
     hiddenFormElements();
     echo $this->getHidden();
     echo "</form>\n";
     echo $lang['FldsRequired'] ."\n";
     echo $this->setfocus("fileadd.name");
   }
   /**
    * navigate
    */
   Function navigate() {
   }

   /**
    * init
    */
   Function initialize() {
     if ( isset($_GET['serverpath']) ){
       $this->serverpath = $_GET['serverpath'];
     } else {
       $this->serverpath = "/tmp/test";
     }

     if ( isset($_GET['afn']) ) {
       # Check the author full name
       $this->xfn['a'] = $_GET['afn'];
       $this->author = check_field($_GET['afn'],"afn","al","at");
     }

     if ($this->author == 0) {
       $this->author = $this->user;
     }
     if ( isset($_GET['pfn']) ) {
       # Check the project
       $this->xfn['p'] = $_GET['pfn'];
       $this->ref = check_field($_GET['pfn'],"pfn","pl","p");
     }
     if ( isset($_GET['pid']) ) {
       # Check the project
       $this->xid['p'] = $_GET['pid'];
       $this->ref = getObject($this->dbconn,$_GET['pid']);
     }
   }
   /**
    * action
    */
   Function action() {
     $this->initialize();

     if ($_GET['action'] == 1) {
       $this->mode = 1;
       return;
     }
     $this->mode = 0;

     $r =  "<br>";
     if ($this->ref == 0) {
       $r .= "No reference given";
       return $r;
     }
     if ($this->author == 0) {
       $r .= "No author given";
       return $r;
     }

     if ( ($_GET['action'] == 2) || ($_GET['action'] == 9) ){
       # TEST the input
       if ( ! is_dir($this->serverpath) ) {
         $r .= $this->serverpath . " is not a directory<br>";
       } else if ( ! is_readable($this->serverpath) ) {
         $r .= $this->serverpath . " is not readable<br>";
       }
       if (!is_writeable($this->serverpath)) {
         $r .= "Directory ". $this->serverpath ." is not writeable (we need this to move files away)<br>";
       }
       if (!is_object($this->author)) {
         $r .= "No author object given";
        return $r;
       }
     }
     if ($_GET['action'] == 2) {
       # Read the whole stuff
       $d = @opendir($this->serverpath);
       @rewinddir($d);
       while (($f = @readdir($d))!= false) {
         if ( $f == "." ) { continue; }
         if ( $f == ".." ) { continue; }
         if (is_dir($this->serverpath."/".$f)) {
           $r .= " ". $this->serverpath ."/". $f ." is a directory<br>";
         }
         if (!is_readable($this->serverpath."/".$f)) {
           $r .= "File: ". $this->serverpath ."/". $f ." is not readable<br>";
         }
       }
     }
     if ($_GET['action'] == 9) {
       # Perform Creation
       # Read the whole stuff
       $d = @opendir($this->serverpath);
       @rewinddir($d);
       while (($f = @readdir($d))!= false) {
         if ( $f == "." ) { continue; }
         if ( $f == ".." ) { continue; }
         if (is_dir($this->serverpath."/".$f)) { continue;}
         if (!is_readable($this->serverpath."/".$f)) { continue;};

         $obj = new tutos_file($this->dbconn);
         $obj->setAuthor($this->author);
         $obj->setVersion("1");
         $obj->setFileName($f);
         $obj->setName($f);

         if ( eregi("\.doc$",$obj->filename) ) {
           $obj->filetype = "application/msword";
		 } else if ( eregi("\.xls$",$obj->filename) ) {
           $obj->filetype = "application/vnd-ms-excel";
		 } else if ( eregi("\.pdf$",$obj->filename) ) {
           $obj->filetype = "application/pdf";
		 } else if ( eregi("\.gif$",$obj->filename) ) {
           $obj->filetype = "image/gif";
		 } else if ( eregi("\.jp[e]g$",$obj->filename) ) {
           $obj->filetype = "image/jpeg";
		 } else {
           $obj->filetype = "plain/text";
		 }

         $obj->logtxt = "automated initial import from ".$this->serverpath."/".$f ;
         $obj->vsys = FILE_RCS;
         $obj->nocheck = true;

         $obj->filesize = filesize($this->serverpath."/".$f);
         $obj->tmploc = $this->serverpath."/".$f;
         $obj->link_id = $this->ref->id;
         $obj->addReference($this->ref);

         $r .= ": ". $obj->getFullName() ." ";
         $r .= $obj->save();
         unset($obj);
         # move the file out of the way
         @rename ($this->serverpath."/".$f , "/tmp/backup/". $f);
         $r .= ".  Original file moved to ". "/tmp/backup/". $f ."<br>";
       }
     }

     return $r;
   }
   /**
    * prepare
    */
   Function prepare() {
     global $msg,$lang,$tutos;

     $this->initialize();
     $this->name = "File Mass Import";
  }
 }

 $l = new file_massimport($current_user);
 $l->display();
 $dbconn->Close();

?>
<!--
    CVS Info:  $Id: file_massimport.php,v 1.1.2.1 2004/08/31 16:55:04 gokohnert Exp $
    $Author: gokohnert $
-->