<?php
/**
 * Copyright 2002 - 2004 by Gero Kohnert
 *
 * this script parses all the inputs and stores the object into the database.
 * on completition it jumps to the detail screen of the stored object
 *
 * @modulegroup group
 * @module group_ins
 * @package group
 */
 $tutos['base'] = "../..";
 ini_set("include_path","..");
 include_once 'permission.p3';
 include_once 'webelements.p3';

 /* Check if user is allowed to use it */
 check_user();
 loadmodules('group','ins');
 loadmodule("group");

 $gotourl = "group/group_new.php";
 $msg = "";

 $obj = new group($dbconn);
 if ( isset($_POST['id']) ) {
   $obj = $obj->read($_POST['id'],$obj);
   $gotourl= addUrlParameter($gotourl,"id=". $obj->id,true);
 }

 if ( !isset($_POST['name']) || empty($_POST['name']) ||  ($_POST['name'] == $lang['PlsChangeName']) ) {
   $msg .= sprintf($lang['Err0009'],$lang['GroupName']) ."<br>";
 } else {
   $obj->setName(trim(StripSlashes($_POST['name'])));
   $gotourl = addUrlParameter($gotourl,"name=". UrlEncode($obj->name),true);
 }
 $gotourl = addUrlParameter($gotourl,"desc=". UrlEncode(StripSlashes($_POST['desc'])),true);

 #
 # Parse additional custom fields
 #
 $msg .= parse_custom_fields($obj->gettype(),$obj);

 # other modules
 $msg .= module_parseforms($current_user,$obj,$gotourl);

 if ( $msg == "" ) {
   $obj->setDesc(trim(StripSlashes($_POST['desc'])));

   $dbconn->Begin("WORK");
   $msg .= $obj->save();
   $dbconn->Commit("WORK");

   $gotourl =  $obj->getURL();
 }
 $gotourl = addMessage($gotourl,$msg,true);
 $gotourl = addSessionKey($gotourl,true);

 Header("Status: 302 Moved Temporarily");
 Header("Location:". dirname(getBaseUrl()) ."/". $gotourl);
 $dbconn->Close();
 /*
  *  CVS Info:  $Id: group_ins.php,v 1.14.2.1 2004/07/26 19:55:03 gokohnert Exp $
  *  $Author: gokohnert $
  */
?>