<?php
/**
 * Copyright 2001 - 2003 by Gero Kohnert
 *
 * @modulegroup group
 * @module group_del
 * @package group
 */
 $tutos['base'] = "../..";
 ini_set("include_path","..");
 include_once 'permission.p3';
 include_once 'webelements.p3';

 /* Check if user is allowed to use it */
 check_user();
 loadmodules("group","del");
 loadmodule("group");

 /* Check Input */
 $msg = "";
 $gotourl = "group/group_overview.php";
 $obj = new group($dbconn);

 if ( !isset($_GET['id']) ) {
   $msg .= sprintf($lang['Err0040'],$lang[$obj->getType()]) ."<br>";
 } else {
   $obj = $obj->read($_GET['id'],$obj);
   $gotourl = $obj->getUrl();
 }
 if ( ! $obj->del_ok() ) {
   $msg .= sprintf($lang['Err0023'],$lang[$obj->getType()]) ."<br>";
 }
 if ( $msg == "" ) {
   $gotourl = "group/group_overview.php";

   $dbconn->Begin("WORK");
   $msg .= $obj->delete();
   $dbconn->Commit("WORK");
 }

 $gotourl = addMessage($gotourl,$msg,true);
 $gotourl = addSessionKey($gotourl,true);

 Header("Status: 302 Moved Temporarily");
 Header("Location: ". dirname(getBaseUrl()) ."/". $gotourl);
 $dbconn->Close();
 /*
  *  CVS Info:  $Id: group_del.php,v 1.10.2.1 2004/07/26 19:55:03 gokohnert Exp $
  *  $Author: gokohnert $
  */
?>