<?php
/**
 * Copyright 1999 - 2003 by Gero Kohnert
 *
 * @modulegroup mailbox
 * @module mailbox_ins
 * @package mailbox
 */
 $tutos['base'] = "../..";
 ini_set("include_path","..");
 include_once 'webelements.p3';
 include_once 'permission.p3';

 /* Check if user is allowed to use it */
 check_user();
 loadmodules('mailbox','ins');
 loadmodule('mailbox');

 $msg = "";
 if ( !isset($_POST['gotourl']) ) {
   $gotourl = "mytutos.php";
 } else {
   $gotourl = $_POST['gotourl'];
 }

 $m = new mailbox($dbconn);
 if ( empty($_POST['id']) ) {
   if ( !isset($_POST['parent']) ||  empty($_POST['parent']) ) {
     $msg .=  "Missing parent";
     $dbconn->Close();
     exit;
   }
   $m->parent = GetObject($dbconn,$_POST['parent']);
 } else {
   $m = $m->read($_POST['id'],$m);
 }

 $m->setHost(StripSlashes($_POST['host']));
 $m->setMBType($_POST['type']);
 $m->port = $_POST['port'];
 $m->setMBPath(StripSlashes($_POST['path']));
 $m->setUser(StripSlashes($_POST['user']));
 $m->pw   = StripSlashes($_POST['mpw']);
 $m->autoimport = $_POST['autoimport'];
 $m->setEmail(StripSlashes($_POST['email']));

 # other modules
 $msg .= module_parseforms($current_user,$m,$gotourl);
 
 if ( $msg == "" ) {
   $dbconn->Begin("WORK");
   $msg .= $m->save();
   $dbconn->Commit("WORK");
 }
 $gotourl = $m->parent->getURL();


 $gotourl = addMessage($gotourl,$msg,true);
 $gotourl = addSessionKey($gotourl,true);

 Header("Status: 302 Moved Temporarily");
 Header("Location: ". dirname(getBaseUrl()) ."/". $gotourl);
 $dbconn->Close();
/*
 *  CVS Info:  $Id: mailbox_ins.php,v 1.5.2.1 2004/07/26 19:55:04 gokohnert Exp $
 *  $Author: gokohnert $
 */
?>