<?php
/**
 * Copyright 1999 - 2003 by Gero Kohnert
 *
 * @modulegroup watchlist
 * @package watchlist
 */
 $tutos['base'] = "../..";
 ini_set("include_path","..");
 include_once 'webelements.p3';
 include_once 'permission.p3';

 /* Check if user is allowed to use it */
 check_user();
 loadmodules("watchlist","ins");
 loadmodule("watchlist");

 /* Check Input */
 $msg = "";
 $w = new watchlist($dbconn);
 if ( empty($_GET['gotourl']) && isset($_SERVER['HTTP_REFERER']) ) {
   Fatal_Error("Missing gotourl");
 }

 if ( empty($_GET['adr']) ) {
   $a = $current_user;
 } else {
   $a = new tutos_address($dbconn);
   $a = $a->read($_GET['adr'],$a);
 }
 if ( empty($_GET['id']) ) {
   $msg .= "Missing ID" ."<br>";
 } else {
   $obj = getObject($dbconn,$_GET['id']);
   if ($obj != -1) {
     $gotourl = dirname(getBaseUrl()) ."/". $obj->getUrl();
   } else {
   $msg .= "Unknown ID" ."<br>";
   }
 }

 if ( $msg == "" ) {
   $dbconn->Begin("WORK");
   $msg .= $w->add($obj->id,$a->id);
   $dbconn->Commit("WORK");
 }

 $gotourl = addMessage($gotourl,$msg,true);
 $gotourl = addSessionKey($gotourl,true);

 Header("Status: 302 Moved Temporarily");
 Header("Location: ". $gotourl);
 $dbconn->Close();
 /*
  *  CVS Info:  $Id: watchlist_ins.php,v 1.12.4.1 2004/07/26 19:55:06 gokohnert Exp $
  *  $Author: gokohnert $
  */
?>